from http import HTTPStatus
from typing import Any, Optional, Union, cast
from uuid import UUID

import httpx

from ... import errors
from ...client import AuthenticatedClient, Client
from ...models.get_reod_v1_user_ctx_id_history_object_id_response_200 import (
    GetReodV1UserCtxIdHistoryObjectIdResponse200,
)
from ...types import UNSET, Response, Unset


def _get_kwargs(
    user_ctx_id: UUID,
    *,
    size: Union[Unset, int] = UNSET,
    page_token: Union[Unset, str] = UNSET,
    path: str,
) -> dict[str, Any]:
    params: dict[str, Any] = {}

    params["size"] = size

    params["pageToken"] = page_token

    params["path"] = path

    params = {k: v for k, v in params.items() if v is not UNSET and v is not None}

    _kwargs: dict[str, Any] = {
        "method": "get",
        "url": f"/reod/v1/{user_ctx_id}/history/object-id",
        "params": params,
    }

    return _kwargs


def _parse_response(
    *, client: Union[AuthenticatedClient, Client], response: httpx.Response
) -> Optional[Union[Any, GetReodV1UserCtxIdHistoryObjectIdResponse200]]:
    if response.status_code == 200:
        response_200 = GetReodV1UserCtxIdHistoryObjectIdResponse200.from_dict(response.json())

        return response_200
    if response.status_code == 400:
        response_400 = cast(Any, None)
        return response_400
    if response.status_code == 401:
        response_401 = cast(Any, None)
        return response_401
    if response.status_code == 403:
        response_403 = cast(Any, None)
        return response_403
    if response.status_code == 404:
        response_404 = cast(Any, None)
        return response_404
    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(
    *, client: Union[AuthenticatedClient, Client], response: httpx.Response
) -> Response[Union[Any, GetReodV1UserCtxIdHistoryObjectIdResponse200]]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    user_ctx_id: UUID,
    *,
    client: Union[AuthenticatedClient, Client],
    size: Union[Unset, int] = UNSET,
    page_token: Union[Unset, str] = UNSET,
    path: str,
) -> Response[Union[Any, GetReodV1UserCtxIdHistoryObjectIdResponse200]]:
    """Your GET endpoint

     Return an Array of all objectIds which are or were under this path. Get all revision for one of this
    ids using /history/revision?objectId=.

    Args:
        user_ctx_id (UUID):
        size (Union[Unset, int]):
        page_token (Union[Unset, str]):
        path (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union[Any, GetReodV1UserCtxIdHistoryObjectIdResponse200]]
    """

    kwargs = _get_kwargs(
        user_ctx_id=user_ctx_id,
        size=size,
        page_token=page_token,
        path=path,
    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)


def sync(
    user_ctx_id: UUID,
    *,
    client: Union[AuthenticatedClient, Client],
    size: Union[Unset, int] = UNSET,
    page_token: Union[Unset, str] = UNSET,
    path: str,
) -> Optional[Union[Any, GetReodV1UserCtxIdHistoryObjectIdResponse200]]:
    """Your GET endpoint

     Return an Array of all objectIds which are or were under this path. Get all revision for one of this
    ids using /history/revision?objectId=.

    Args:
        user_ctx_id (UUID):
        size (Union[Unset, int]):
        page_token (Union[Unset, str]):
        path (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union[Any, GetReodV1UserCtxIdHistoryObjectIdResponse200]
    """

    return sync_detailed(
        user_ctx_id=user_ctx_id,
        client=client,
        size=size,
        page_token=page_token,
        path=path,
    ).parsed


async def asyncio_detailed(
    user_ctx_id: UUID,
    *,
    client: Union[AuthenticatedClient, Client],
    size: Union[Unset, int] = UNSET,
    page_token: Union[Unset, str] = UNSET,
    path: str,
) -> Response[Union[Any, GetReodV1UserCtxIdHistoryObjectIdResponse200]]:
    """Your GET endpoint

     Return an Array of all objectIds which are or were under this path. Get all revision for one of this
    ids using /history/revision?objectId=.

    Args:
        user_ctx_id (UUID):
        size (Union[Unset, int]):
        page_token (Union[Unset, str]):
        path (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Union[Any, GetReodV1UserCtxIdHistoryObjectIdResponse200]]
    """

    kwargs = _get_kwargs(
        user_ctx_id=user_ctx_id,
        size=size,
        page_token=page_token,
        path=path,
    )

    response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(client=client, response=response)


async def asyncio(
    user_ctx_id: UUID,
    *,
    client: Union[AuthenticatedClient, Client],
    size: Union[Unset, int] = UNSET,
    page_token: Union[Unset, str] = UNSET,
    path: str,
) -> Optional[Union[Any, GetReodV1UserCtxIdHistoryObjectIdResponse200]]:
    """Your GET endpoint

     Return an Array of all objectIds which are or were under this path. Get all revision for one of this
    ids using /history/revision?objectId=.

    Args:
        user_ctx_id (UUID):
        size (Union[Unset, int]):
        page_token (Union[Unset, str]):
        path (str):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Union[Any, GetReodV1UserCtxIdHistoryObjectIdResponse200]
    """

    return (
        await asyncio_detailed(
            user_ctx_id=user_ctx_id,
            client=client,
            size=size,
            page_token=page_token,
            path=path,
        )
    ).parsed
